scan_atheros() {
local device="$1"
local wds
- local adhoc sta ap
+ local adhoc ahdemo sta ap monitor
config_get vifs "$device" vifs
for vif in $vifs; do
esac
done
- case "${adhoc:+1}:${sta:+1}:${ap+1}" in
+ case "${adhoc:+1}:${sta:+1}:${ap:+1}" in
# valid mode combinations
1::) wds="";;
1::1);;
*) echo "$device: Invalid mode combination in config"; return 1;;
esac
- config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }${monitor:+$monitor}"
+ config_set "$device" vifs "${sta:+$sta }${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${wds:+$wds }${monitor:+$monitor}"
}
local device="$1"
set_wifi_down "$device"
- # kill all running hostapd and wpa_supplicant processes that
- # are running on atheros vifs
- for pid in `pidof hostapd wpa_supplicant`; do
- grep ath /proc/$pid/cmdline >/dev/null && \
- kill $pid
- done
include /lib/network
cd /proc/sys/net
for dev in *; do
grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
- ifconfig "$dev" down
+ [ -f "/var/run/wifi-${dev}.pid" ] &&
+ kill "$(cat "/var/run/wifi-${dev}.pid")"
+ ifconfig "$dev" down
unbridge "$dev"
wlanconfig "$dev" destroy
}
enable_atheros() {
local device="$1"
+
+ config_get regdomain "$device" regdomain
+ [ -n "$regdomain" ] && echo "$regdomain" > /proc/sys/dev/$device/regdomain
+
+ config_get country "$device" country
+ [ -z "$country" ] && country="0"
+ echo "$country" > /proc/sys/dev/$device/countrycode
+
+ config_get_bool outdoor "$device" outdoor "0"
+ echo "$outdoor" > /proc/sys/dev/$device/outdoor
+
config_get channel "$device" channel
config_get vifs "$device" vifs
+ config_get txpower "$device" txpower
[ auto = "$channel" ] && channel=0
- local first=1
+ config_get_bool antdiv "$device" diversity
+ config_get antrx "$device" rxantenna
+ config_get anttx "$device" txantenna
+ config_get_bool softled "$device" softled 1
+
+ devname="$(cat /proc/sys/dev/$device/dev_name)"
+ local antgpio=
+ local invert=
+ case "$devname" in
+ NanoStation2) antgpio=7; invert=1;;
+ NanoStation5) antgpio=1; invert=1;;
+ "NanoStation Loco2") antgpio=2;;
+ esac
+ if [ -n "$invert" ]; then
+ _set="clear"
+ _clear="set"
+ else
+ _set="set"
+ _clear="clear"
+ fi
+ if [ -n "$antgpio" ]; then
+ softled=0
+ config_get antenna "$device" antenna
+ case "$antenna" in
+ external) antdiv=0; antrx=1; anttx=1 ;;
+ horizontal) antdiv=0; antrx=1; anttx=1 ;;
+ vertical) antdiv=0; antrx=2; anttx=2 ;;
+ auto) antdiv=1; antrx=0; anttx=0 ;;
+ esac
+
+ [ -x "$(which gpioctl 2>/dev/null)" ] || antenna=
+ gpioctl "dirout" "$antgpio" >/dev/null 2>&1
+ case "$antenna" in
+ horizontal|vertical|auto)
+ gpioctl "$_clear" "$antgpio" >/dev/null 2>&1
+ ;;
+ external)
+ gpioctl "$_set" "$antgpio" >/dev/null 2>&1
+ ;;
+ esac
+ fi
+
+ [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
+ [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
+ [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
+ [ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
+
+ config_get distance "$device" distance
+ [ -n "$distance" ] && sysctl -w dev."$device".distance="$distance" >&-
+
for vif in $vifs; do
- local start_hostapd
- nosbeacon=
+ local start_hostapd= vif_txpower= nosbeacon=
config_get ifname "$vif" ifname
config_get enc "$vif" encryption
config_get eap_type "$vif" eap_type
config_get mode "$vif" mode
- [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
+ case "$mode" in
+ sta) config_get_bool nosbeacon "$device" nosbeacon;;
+ adhoc) config_get_bool nosbeacon "$vif" sw_merge 1;;
+ esac
- config_get ifname "$vif" ifname
+ [ "$nosbeacon" = 1 ] || nosbeacon=""
ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
[ $? -ne 0 ] && {
echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
}
config_set "$vif" ifname "$ifname"
- # only need to change freq band and channel on the first vif
- config_get agmode "$device" agmode
- [ -z "$agmode" ] && config_get agmode "$device" mode
+ config_get hwmode "$device" hwmode
+ [ -z "$hwmode" ] && config_get hwmode "$device" mode
pureg=0
- case "$agmode" in
- *b) agmode=11b;;
- *bg) agmode=11g;;
- *g) agmode=11g; pureg=1;;
- *gdt) agmode=11gdt;;
- *a) agmode=11a;;
- *adt) agmode=11adt;;
- *ast) agmode=11ast;;
- *fh) agmode=fh;;
- *) agmode=auto;;
+ case "$hwmode" in
+ *b) hwmode=11b;;
+ *bg) hwmode=11g;;
+ *g) hwmode=11g; pureg=1;;
+ *gdt) hwmode=11gdt;;
+ *a) hwmode=11a;;
+ *adt) hwmode=11adt;;
+ *ast) hwmode=11ast;;
+ *fh) hwmode=fh;;
+ *) hwmode=auto;;
esac
- iwpriv "$ifname" mode "$agmode"
+ iwpriv "$ifname" mode "$hwmode"
iwpriv "$ifname" pureg "$pureg"
- [ "$first" = 1 ] && {
- iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
- }
-
+ iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
+
config_get_bool hidden "$vif" hidden 0
iwpriv "$ifname" hide_ssid "$hidden"
1|on|enabled) wds=1;;
*) wds=0;;
esac
- iwpriv "$ifname" wds "$wds"
+ iwpriv "$ifname" wds "$wds" >/dev/null 2>&1
[ "$mode" = ap -a "$wds" = 1 ] && {
config_get_bool wdssep "$vif" wdssep 1
esac
case "$mode" in
- adhoc|ahdemo)
+ sta|adhoc|ahdemo)
config_get addr "$vif" bssid
[ -z "$addr" ] || {
iwconfig "$ifname" ap "$addr"
}
;;
esac
- config_get ssid "$vif" ssid
+
+ config_get_bool uapsd "$vif" uapsd 0
+ iwpriv "$ifname" uapsd "$uapsd"
config_get_bool bgscan "$vif" bgscan
[ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
- config_get_bool antdiv "$device" diversity
- [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
-
- config_get antrx "$device" rxantenna
- [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
-
- config_get anttx "$device" txantenna
- [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
-
- config_get distance "$device" distance
- [ -n "$distance" ] && athctrl -i "$device" -d "$distance" >&-
-
- config_get_bool softled "$device" softled 1
- [ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
-
- config_get txpwr "$vif" txpower
- [ -n "$txpwr" ] && iwconfig "$ifname" txpower "${txpwr%%.*}"
-
config_get rate "$vif" rate
[ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
config_get rts "$vif" rts
[ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
- config_get_bool comp "$vif" compression
- [ -n "$comp" ] && iwpriv "$ifname" compression "$comp"
+ config_get_bool comp "$vif" compression 0
+ iwpriv "$ifname" compression "$comp" >/dev/null 2>&1
config_get_bool minrate "$vif" minrate
[ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
config_get_bool ar "$vif" ar
[ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
- config_get_bool turbo "$vif" turbo
- [ -n "$turbo" ] && iwpriv "$ifname" turbo "$turbo"
+ config_get_bool beacon_power "$vif" beacon_power
+ [ -n "$beacon_power" ] && iwpriv "$ifname" beacon_pwr "$beacon_power"
config_get_bool doth "$vif" doth 0
[ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
+ config_get_bool probereq "$vif" probereq
+ [ -n "$probereq" ] && iwpriv "$ifname" probereq "$probereq"
+
config_get maclist "$vif" maclist
[ -n "$maclist" ] && {
# flush MAC list
esac
ifconfig "$ifname" up
+
local net_cfg bridge
net_cfg="$(find_net_config "$vif")"
[ -z "$net_cfg" ] || {
config_set "$vif" bridge "$bridge"
start_net "$ifname" "$net_cfg"
}
- iwconfig "$ifname" essid "$ssid"
+
+ config_get ssid "$vif" ssid
+ [ -n "$ssid" ] && {
+ iwconfig "$ifname" essid on
+ iwconfig "$ifname" essid "$ssid"
+ }
+
set_wifi_up "$vif" "$ifname"
+
+ # TXPower settings only work if device is up already
+ # while atheros hardware theoretically is capable of per-vif (even per-packet) txpower
+ # adjustment it does not work with the current atheros hal/madwifi driver
+
+ config_get vif_txpower "$vif" txpower
+ # use vif_txpower (from wifi-iface) instead of txpower (from wifi-device) if
+ # the latter doesn't exist
+ txpower="${txpower:-$vif_txpower}"
+ [ -z "$txpower" ] || iwconfig "$ifname" txpower "${txpower%%.*}"
+
case "$mode" in
ap)
config_get_bool isolate "$vif" isolate 0
fi
;;
esac
- first=0
done
}
[ -d ath ] || return
for dev in $(ls -d wifi* 2>&-); do
config_get type "$dev" type
- [ "$type" = atheros ] && return
+ devname="$(cat /proc/sys/dev/$dev/dev_name)"
+ case "$devname" in
+ NanoStation*)
+ EXTRA_DEV="
+# Ubiquiti NanoStation features
+ option antenna auto # (auto|horizontal|vertical|external)
+"
+ ;;
+ esac
+ [ "$type" = atheros ] && continue
cat <<EOF
config wifi-device $dev
option type atheros
option channel auto
-
+$EXTRA_DEV
# REMOVE THIS LINE TO ENABLE WIFI:
option disabled 1